package com.key.vibekeyboard.Adapter;

import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.CenterCrop;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestOptions;
import com.key.vibekeyboard.Activity.DownloadActivity;
import com.key.vibekeyboard.R;
import com.key.vibekeyboard.Room.Category;
import com.key.vibekeyboard.Room.WallpaperInfo;

import java.util.ArrayList;
import java.util.List;

public class HomeRecyclerViewAdapter extends RecyclerView.Adapter<HomeRecyclerViewAdapter.HomeRecyclerViewHolder> {

    private List<Category> categories;
    private Context context;

    public HomeRecyclerViewAdapter(Context context,List<Category> categories) {
        this.context = context;
        this.categories = categories;
    }

    @NonNull
    @Override
    public HomeRecyclerViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.home_recycler_item, parent, false);
        return new HomeRecyclerViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull HomeRecyclerViewHolder holder, int position) {

        Category category = categories.get(position);
        List<WallpaperInfo> list = category.getList();
        WallpaperInfo categoryWallpaperInfo = category.getList().get(position);
        WallpaperInfo wallpaperInfo = category.getList().get(0);

        List<WallpaperInfo> limitedList = list.subList(0, Math.min(20, list.size()));

        holder.imageView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent(context, DownloadActivity.class);
                intent.putExtra("wallpaperInfo", wallpaperInfo); // wallpaperInfo 已经实现了 Parcelable
                intent.putParcelableArrayListExtra("list", new ArrayList<>(limitedList)); // list 中的 WallpaperInfo 对象实现了 Parcelable
                context.startActivity(intent);
            }
        });


        // 应用圆角变换
        RequestOptions options = new RequestOptions()
                .placeholder(R.mipmap.splash)
                .error(R.mipmap.splash)
                .transform(new CenterCrop())
                .transform(new RoundedCorners(16)); // 设置圆角度数

        Glide.with(context)
                .load(wallpaperInfo.getPreview())
                .apply(options)
                .into(holder.imageView);
    }

    @Override
    public int getItemCount() {
        return categories.size();
    }

    public static class HomeRecyclerViewHolder extends RecyclerView.ViewHolder {
        private ImageView imageView;

            public HomeRecyclerViewHolder(View view) {
                super(view);
                imageView = view.findViewById(R.id.home_recycler_image);
            }
        }


}
